function [w,mapeo]=cdoqm(arg1,arg2)
% cdoqm: class mean distance optimization quadratic mapping (CDOQM)
	global n
	global C
	
    x=arg1;np=size(x,1);p=n*(n+1)/2;
    ncol=n+p;z=zeros(np,ncol);
    
	% cálculo de vector w en 2D para patróns z non vistos durante o cálculo da proxección
    if 1==nargout()
        mapeo=arg2;ind=mapeo.ind;
        x=bsxfun(@minus,x,mapeo.media);
        z(:,1:n)=x;  % mapeo cadrático
        for i=1:np
            t=x(i,:);u=t'*t;z(i,n+1:n+p)=u(ind);
        end
        w=z*mapeo.A;return
    end
	
    cl=arg2;
    mapeo.media=mean(x);x=bsxfun(@minus,x,mapeo.media);
    k=1;ind=zeros(1,p);
    for i=1:n
        for j=i:n
            ind(k)=(i-1)*n+j;k=k+1;
        end
    end
    mapeo.ind=ind;z(:,1:n)=x;  % mapeo cadrático        
    for i=1:np
        t=x(i,:);u=t'*t;z(i,n+1:n+p)=u(ind);
    end

	m=zeros(C,ncol);
    for i=1:C
        m(i,:)=mean(z(cl==i,:));
    end
    % cov(m) é igual á matriz de covarianza da matriz das medias de clase,
    % agás un factor constante
    Z=cov(m);[V,L]=eig(Z);
    L(~isfinite(L))=0;L(imag(L)~=0)=0;
    [~,ind]=sort(abs(diag(L)),'descend');
    A=V(:,ind(1:2));w=z*A;mapeo.A=A;
end
