function [w,mapeo]=dsopm(arg1,arg2,arg3)
% dsopm: direct class separability optimization polynomial mapping (DSOPM)
	global C

    x=arg1;D=arg2;
    np=size(x,1);fct=factorial(1:D);
    
    % cálculo de vector w en 2D para patróns x non vistos durante o cálculo da proxección
    if 1==nargout()
        mapeo=arg3;x=bsxfun(@minus,x,mapeo.media);
        tz=x;z=tz; % mapeo polinómico (so termos puros)
        for d=2:D
            z=[z tz.^d/fct(d)];
        end
        w=z*mapeo.A;return
    end
    
    cl=arg3;
    mapeo.media=mean(x);
    x=bsxfun(@minus,x,mapeo.media);

    tz=x;z=tz; % mapeo polinómico (so termos puros)
    for d=2:D
        z=[z tz.^d/fct(d)];
    end

	p=size(z,2);Z=zeros(p);alfa=-ones(1,np);sdz=zeros(p);
    for c=1:C
        ind=find(cl==c);alfa(:)=-1;alfa(ind)=1;
        for j=1:np
            sdz(:)=0;zj=z(j,:);
            for i=ind
                dz=z(i,:)-zj;sdz=sdz+dz'*dz;
            end
            Z=Z+alfa(j)*sdz;
        end
    end
    [V,L]=eig(Z);
        
    L(~isfinite(L))=0;L(imag(L)~=0)=0;
    [~,ind]=sort(abs(diag(L)),'descend');
    
    A=V(:,ind(1:2));w=z*A;mapeo.A=A;
end
