function proxecta(proxeccion,problema)
try
    addpath('libsvm-3.1/matlab');
    addpath('drtoolbox/techniques/');

    global  N
    global  n
    global  C
    global  fr
    global  tempo

    graficos=true;

    fprintf('running %s on data set %s ...\n',proxeccion,problema);
    %rand('seed',0);randn('seed',0); %tsne usa randn
    RandStream.setDefaultStream(RandStream('mcg16807','Seed',0));  % inicializa o xerador de números aleatorios

    % apertura de arquivo de resultados
    nf=sprintf('../resultados/%s/%s/resultados_libsvm_%s_%s.dat',problema,proxeccion,problema,proxeccion);fr=abre(nf,'w');

    %lectura de información sobre o problema
    nf=sprintf('../datos/%s/%s.txt',problema,problema);f=abre(nf,'r');
    fscanf(f,'%s',1);N=fscanf(f,'%i',1);  % nº patróns
    fscanf(f,'%s',1);n=fscanf(f,'%i',1);  % nº entradas
    fscanf(f,'%s',1);C=fscanf(f,'%i',1);  % nº clases
    fscanf(f,'%s',1);nar=fscanf(f,'%i',1);  % nº arquivos
    if 2==nar  % se hai arquivo de teste aparte
        fscanf(f,'%s',1);fscanf(f,'%i',1);
    end
    fscanf(f,'%s',1);kfold=fscanf(f,'%i',1);  % kfold
    fclose(f);

    %lectura de arquivo cos datos
    z=zeros(N,n);cl=zeros(1,N);
    nf=sprintf('../datos/%s/%s_R.dat',problema,problema);f=abre(nf,'r');
    fscanf(f,'%s',n+1);
    for i=1:N
        fscanf(f,'%i',1);z(i,:)=fscanf(f,'%g',n)';
        cl(i)=fscanf(f,'%i',1);  % as saídas desexadas deben estar entre 1 e C
    end
    fclose(f);

    % lectura de particions en conxuntos.dat
    nf=sprintf('../datos/%s/conxuntos.dat',problema);f=abre(nf,'r');
    npe=fscanf(f,'%i',1);npv=fscanf(f,'%i',1);npt=fscanf(f,'%i',1);
    xe=zeros(kfold,npe);xv=zeros(kfold,npv);xt=zeros(kfold,npt);
    for i=1:kfold
        xe(i,:)=fscanf(f,'%i',npe);xv(i,:)=fscanf(f,'%i',npv);xt(i,:)=fscanf(f,'%i',npt);
    end
    fclose(f);

    % bandeiras para saber de que tipo é a proxeccion
    nosa=prox_nosa(proxeccion);
    if ~nosa
        oos=outofsample(proxeccion);
    end

    % crea conxuntos de entrenamento, validación e teste en 2D
    no_dims=2;
    if strcmp(proxeccion,'LDA') && 2==C
        no_dims=1;
    end

    we=zeros(npe,no_dims,kfold);wv=zeros(npv,no_dims,kfold);wt=zeros(npt,no_dims,kfold);
    if true==nosa
        for i=1:kfold
            pe=xe(i,:);ze=z(pe,:);pv=xv(i,:);zv=z(pv,:);pt=xt(i,:);zt=z(pt,:);cle=cl(pe);
            [we(:,:,i),mapeo]=exec_prox_nosa(proxeccion,ze,cle);
            wv(:,:,i)=teste_prox_nosa(proxeccion,mapeo,zv);
            wt(:,:,i)=teste_prox_nosa(proxeccion,mapeo,zt);
        end
    else
        for i=1:kfold
            pe=xe(i,:);ze=z(pe,:);pv=xv(i,:);zv=z(pv,:);pt=xt(i,:);zt=z(pt,:);cle=cl(pe);
            [t,mapeo]=exec_prox_drt(proxeccion,ze,cle);
            if size(t,1)~=npe
                fprintf('%s retorna %i patróns e debería retornar %i\n',proxeccion,size(t,1),npe);
                fprintf(fr,'%s retorna %i patróns e debería retornar %i\n',proxeccion,size(t,1),npe);fclose(fr);exit
            end
            we(:,:,i)=t;
            if true==oos
                wv(:,:,i)=out_of_sample(zv,mapeo);wt(:,:,i)=out_of_sample(zt,mapeo);
            else
                twe=we(:,:,i);wv(:,:,i)=out_of_sample_est(zv,ze,twe);wt(:,:,i)=out_of_sample_est(zt,ze,twe);
            end
        end
    end

    fprintf(fr,'tempo_%s= %g s.\n',proxeccion,tempo);

    %preprocesamento media 0 desviación 1
    for i=1:kfold
%         t=we(:,:,i);med=mean(t);desv=std(t);        
%         we(:,:,i)=bsxfun(@rdivide,bsxfun(@minus,we(:,:,i),med),desv);
%         wv(:,:,i)=bsxfun(@rdivide,bsxfun(@minus,wv(:,:,i),med),desv);
%         wt(:,:,i)=bsxfun(@rdivide,bsxfun(@minus,wt(:,:,i),med),desv);

        for j=1:no_dims
            t=we(:,j,i);med=mean(t);desv=std(t);we(:,j,i)=(we(:,j,i)-med)/desv;
%              t=wv(:,j,i);med=mean(t);desv=std(t);
            wv(:,j,i)=(wv(:,j,i)-med)/desv;
%              t=wt(:,j,i);med=mean(t);desv=std(t);
            wt(:,j,i)=(wt(:,j,i)-med)/desv;
        end
    end
    
    % almacenamento e representación gráfica dos patróns de entrenamento en 2D
    if true==graficos
        representa
    end

    % entrena e sintoniza SVM
    fprintf('classifying with LibSVM ...\n');fprintf('%10s\t%10s\n','progress','%kappa');
    fprintf(fr,'%10s\t%10s\t%10s\n','C','gamma','%kappa');
    vC=2.^(15:-2:-5);nvC=length(vC);vG=2.^(3:-2:-15);nvG=length(vG);kappa=zeros(1,kfold);
    iexp=0;nexp=nvC*nvG;kappa_mellor=-inf;C_mellor=vC(1);G_mellor=vG(1);mc_med=zeros(C);mc_mellor=zeros(C);
    for i=1:nvC
        for j=1:nvG
            mc_med(:)=0;opct=sprintf('-s 0 -t 2 -c %g -g %g -q',vC(i),vG(j));  % opcións de svmtrain
            for k=1:kfold
                pe=xe(k,:);sd=cl(pe)';svm=svmtrain(sd,we(:,:,k),opct);
                pv=xv(k,:);sd=cl(pv)';sr=svmpredict(sd,wv(:,:,k),svm);
                [kappa(k),mc]=avalia(sd,sr);mc_med=mc_med+mc;
            end
            kappa_med=mean(kappa);mc_med=mc_med/kfold;
            if kappa_med > kappa_mellor
                kappa_mellor=kappa_med;C_mellor=vC(i);G_mellor=vG(j);mc_mellor=mc_med;
            end
            fprintf('%9.2f%%\t%9.2f%%\r', 100*iexp/nexp,kappa_mellor);iexp=iexp+1;
            fprintf(fr,'%10f\t%10f\t%6.2f\n',vC(i),vG(j),kappa_med);
        end
    end
    fprintf('\n');
    fprintf(fr,'C_mellor= %g G_mellor= %g kappa_mellor= %6.2f%%\n',C_mellor,G_mellor,kappa_mellor);
    escribe(mc_mellor,'mellor');

    % testea SVM sobre conxuntos de teste
    mc_med(:)=0;opct=sprintf('-s 0 -t 2 -c %g -g %g -q',C_mellor,G_mellor);
    for i=1:kfold
        pe=xe(i,:);sd=cl(pe)';svm=svmtrain(sd,we(:,:,i),opct);
        pt=xt(i,:);sd=cl(pt)';sr=svmpredict(sd,wt(:,:,i),svm);
        [kappa(i),mc]=avalia(sd,sr);mc_med=mc_med+mc;
        fprintf('%6.2f%%\r', 100*iexp/nexp);iexp=iexp+1;
    end
    kappa_med=mean(kappa);mc_med=mc_med/kfold;
    fprintf(fr,'kappa_final= %6.2f\n',kappa_med);
    escribe(mc_med,'teste (kfold)');

    % almacena o kappa en kappa.dat
    nf=sprintf('../resultados/%s/%s/kappa.dat',problema,proxeccion);f=abre(nf,'w');
    fprintf(f,'%6.2f\n',kappa_med);fclose(f);

    fprintf('%s %s: kappa= %6.2f%%\n',proxeccion,problema,kappa_med);

    fclose(fr);
catch excepcion
    fprintf('matlab: excepción: proxección= %s problema= %s\n',proxeccion,problema)
    fprintf('id= %s: message= %s\n', excepcion.identifier, excepcion.message)
    fprintf('stack:\n')
    for i=1:size(excepcion.stack,1)
        fprintf('%s nome=%s linha=%i\n',excepcion.stack(i).file,...
            excepcion.stack(i).name,excepcion.stack(i).line)
    end
end
% exit