% almacenamento dos patróns de entrenamento do fold 1 en 2D; representación gráfica 
% do mapa creado por SVM, e dos patróns de entrenamento/validación/teste (fold 1)
fprintf('creating plots ...\n');

fold=1;pe=xe(fold,:);cle=cl(pe);

% almacenamiento de patróns proxectados a 2D
nf=sprintf('../resultados/%s/%s/%s_2D_%s.dat',problema,proxeccion,problema,proxeccion);f=abre(nf,'w');
if 1==no_dims
    fprintf(f,'\t%10s\t%10s\n','f1','clase');
else
    fprintf(f,'\t%10s\t%10s\t%10s\n','f1','f2','clase');
end
for i=1:npe
	fprintf(f,'%i',i);fprintf(f,'\t%10f',we(i,:,fold));fprintf(f,'\t%10i\n',cle(i));
end
fclose(f);

C_max=8;cor={'b','r','y','g','w','m','c','k'};label=cell(1,C);
if C>C_max
	fprintf('nº de clases %i superior a nº de cores %i\n',C,C_max);
	fprintf('so representa os patróns das %i primeiras clases\n',C_max);
end
vC=2.^(15:-2:-5);nvC=length(vC);vG=2.^(3:-2:-15);nvG=length(vG);

figure('visible','off');

if 1==no_dims
    % patróns proxectados a 1D
    clf; hold on
    for i=1:C
        label{i}=sprintf('class %i',i);ind=find(cle==i);
        c=hist(we(ind,1,fold),100);u=linspace(-2,2,length(c));plot(u,c,cor{i});
    end
    title(sprintf('1D train patterns mapped by %s for data set %s',proxeccion,problema));grid on;
    h=legend(label,'location','northeastoutside'); set(h,'fontsize',10,'fontname','helvetica')    
    nf=sprintf('../resultados/%s/%s/proxeccion_%s_%s.png',problema,proxeccion,problema,proxeccion);print('-dpng',nf);
    
    % mapa en 1D coa saída do clasificador LibSVM
    kappa_mellor=-inf;C_mellor=vC(1);G_mellor=vG(1);
    we2=we(:,:,fold);sde=cle';wv2=wv(:,:,fold);sdv=cl(pv)';
    for i=1:nvC
        for j=1:nvG
            opct=sprintf('-s 0 -t 2 -c %g -g %g -q',vC(i),vG(j));  % opcións de svmtrain
            svm=svmtrain(sde,we2,opct);
            sr=svmpredict(sdv,wv2,svm);
            [kappa,~]=avalia(sdv,sr);
            if kappa > kappa_mellor
                kappa_mellor=kappa;C_mellor=vC(i);G_mellor=vG(j);
            end
 %          fprintf('%10.2f%%\t%10.2f%%\r', 100*iexp++/nexp,kappa_mellor);
        end
    end
%     fprintf('C_mellor= %g G_mellor= %g kappa_mellor= %6.2f%%\n',C_mellor,G_mellor,kappa_mellor);

    opct=sprintf('-s 0 -t 2 -c %g -g %g -b 1 -q',C_mellor,G_mellor);svm=svmtrain(sde,we2,opct);
    w2=(-2:0.01:2)';nw2=length(w2);sd=rand(nw2,1);sr=svmpredict(sd,w2,svm);
    clf;plot(w2,sr);grid on;axis([-2 2 1-0.2 C+0.2])
    title(sprintf('LibSVM classification for 1D train patterns mapped by %s for data set %s',proxeccion,problema));
    nf=sprintf('../resultados/%s/%s/mapa_libsvm_%s_%s.png',problema,proxeccion,problema,proxeccion);print('-dpng',nf);
    return
end

%figura con tódalas clases; cores {blue red green black magenta cyan yellow white}
if npe>500
	tam_punto=2;
else
	tam_punto=4;
end
clf;hold on
for i=1:min(C_max,C)
	format=sprintf('%cs',cor{i});label{i}=sprintf('class %i',i);
    te=find(cle==i);tv=find(cl(pv)==i);tt=find(cl(pt)==i);
    t=[we(te,:,fold) ; wv(tv,:,fold) ; wt(tt,:,fold)];
    plot(t(:,1),t(:,2),format,'markerfacecolor',cor{i},'markersize',tam_punto)
%     ind=find(cle==i);
%   	plot(we(ind,1,fold),we(ind,2,fold),format,'markerfacecolor',cor{i},'markersize',tam_punto)
%     ind=find(cl(pv)==i);
%   	plot(wv(ind,1,fold),wv(ind,2,fold),format,'markerfacecolor',cor{i},'markersize',tam_punto)
%     ind=find(cl(pt)==i);
%   	plot(wt(ind,1,fold),wt(ind,2,fold),format,'markerfacecolor',cor{i},'markersize',tam_punto)
end
h=legend(label,'location','northeastoutside'); set(h,'fontsize',10,'fontname','helvetica')
axis([-2 2 -2 2],'square','ij');grid on;xlabel('Coord. #1');ylabel('Coord. #2');
title(sprintf('2D patterns mapped by %s for data set %s',proxeccion,problema)); hold off
nf=sprintf('../resultados/%s/%s/proxeccion_%s_%s.png',problema,proxeccion,problema,proxeccion);
print('-dpng',nf);

% % figuras con clases separadas
% for i=1:C
% 	ind=find(cl==i);format=sprintf('%cs',cor{i});
% 	plot(we(ind,1,fold),we(ind,2,fold),format,'markerfacecolor',cor{i},'markersize',2)
% 	grid on;axis([-2 2 -2 2],'square','ij')
% 	xlabel('Coord. %1');ylabel('Coord. %2');title(sprintf('2D %s proyection for %s class %i',proxeccion,problema,i))
% 	nf=sprintf('../resultados/%s/%s/proxeccion_%s_%s_clase%i.png',problema,proxeccion,problema,proxeccion,i);
% 	print('-dpng',nf);
% end

% entrena e sintoniza SVM sobre os datos mapeados (somentes o fold 1) para calcular C_mellor e G_mellor
% fprintf('%10s\t%10s\n','progress','%kappa');
% iexp=0;nexp=nvC*nvG;
kappa_mellor=-inf;C_mellor=vC(1);G_mellor=vG(1);
we2=we(:,:,fold);sde=cle';wv2=wv(:,:,fold);sdv=cl(pv)';
for i=1:nvC
	for j=1:nvG
		opct=sprintf('-s 0 -t 2 -c %g -g %g -q',vC(i),vG(j));  % opcións de svmtrain
		svm=svmtrain(sde,we2,opct);
		sr=svmpredict(sdv,wv2,svm);
		[kappa,~]=avalia(sdv,sr);
		if kappa > kappa_mellor
			kappa_mellor=kappa;C_mellor=vC(i);G_mellor=vG(j);
		end
% 		fprintf('%10.2f%%\t%10.2f%%\r', 100*iexp++/nexp,kappa_mellor);
	end
end
% fprintf('C_mellor= %g G_mellor= %g kappa_mellor= %6.2f%%\n',C_mellor,G_mellor,kappa_mellor);

% gráfica co mapa das clases construidas por LibSVM: entrena no conxunto de 
%  entrenamento completo e testea nos puntos da imaxe: rango -3 <= x,y <= 3
l=800;x=linspace(-3,3,l);y=linspace(-3,3,l);
[xx,yy]=meshgrid(x,y);w2=[xx(:) yy(:)];nw2=size(w2,1);
opct=sprintf('-s 0 -t 2 -c %g -g %g -b 1 -q',C_mellor,G_mellor);svm=svmtrain(cle',we(:,:,fold),opct);

% sen probabilidades
% sd=rand(nw2,1);sr=svmpredict(sd,w2,svm);pr=ones(l*l,1);
% con probabilidades
opcp='-b 1';sd=rand(nw2,1);[sr,~,pr]=svmpredict(sd,w2,svm,opcp);pr=0.1*round(10*max(pr,[],2)); 

% create the map with the class borders
%       BLUE     RED    YELLOW  GREEN   WHITE  MAGENTA   CYAN   BLACK
cores=[[0 0 1];[1 0 0];[1 1 0];[0 1 0];[1 1 1];[1 0 1];[0 1 1];[0 0 0];];
t=bsxfun(@times,pr,cores(sr,:));mapa=zeros(l,l,3);
mapa(:,:,1)=reshape(t(:,1),l,l);mapa(:,:,2)=reshape(t(:,2),l,l);mapa(:,:,3)=reshape(t(:,3),l,l);
vermello=cores(:,1);verde=cores(:,2);azul=cores(:,3);lc=7;lc2=floor(lc/2);    %lc=lado do cadrado

nnp=0;
for i=1:npe
	tx=we(i,1,fold);ty=we(i,2,fold);c=cle(i);pinta_patron
end
pv=xv(fold,:);clv=cl(pv);
for i=1:npv
	tx=wv(i,1,fold);ty=wv(i,2,fold);c=clv(i);pinta_patron
end
pt=xt(fold,:);clt=cl(pt);
for i=1:npt
	tx=wt(i,1,fold);ty=wt(i,2,fold);c=clt(i);pinta_patron
end
imagesc(mapa);
nf=sprintf('../resultados/%s/%s/mapa_libsvm_%s_%s.png',problema,proxeccion,problema,proxeccion);
imwrite(mapa,nf);
