function svmNd(problema)
try
    addpath('./libsvm-3.1/matlab');

    global C
    global fr

    RandStream.setDefaultStream(RandStream('mcg16807','Seed',0));  % inicializa o xerador de números aleatorios

    nf=sprintf('../resultados/%s/svmNd/resultados_libsvm_%s_svmNd.dat',problema,problema);fr=abre(nf,'w');

    % lectura de datos do problema
    nf=sprintf('../datos/%s/%s.txt',problema,problema);f=abre(nf,'r');
    fscanf(f,'%s',1);N=fscanf(f,'%i',1);
    fscanf(f,'%s',1);n=fscanf(f,'%i',1);
    fscanf(f,'%s',1);C=fscanf(f,'%i',1);
    fscanf(f,'%s',1);nar=fscanf(f,'%i',1);
    if 2==nar
        fscanf(f,'%s',1);fscanf(f,'%i',1);
    end
    fscanf(f,'%s',1);kfold=fscanf(f,'%i',1);
    fclose(f);

    x=zeros(N,n);cl=zeros(1,N);

    % lectura de patróns de entrenamento
    nf=sprintf('../datos/%s/%s_R.dat',problema,problema);f=abre(nf,'r');
    fscanf(f,'%s',n+1);
    for i=1:N
        fscanf(f,'%i',1);x(i,:)=fscanf(f,'%f',n);cl(i)=fscanf(f,'%i',1);
    end
    fclose(f);

    % lectura de particions en conxuntos.dat
    nf=sprintf('../datos/%s/conxuntos.dat',problema);f=abre(nf,'r');
    npe=fscanf(f,'%i',1);npv=fscanf(f,'%i',1);npt=fscanf(f,'%i',1);
    xe=zeros(kfold,npe);xv=zeros(kfold,npv);xt=zeros(kfold,npt);
    for i=1:kfold
        xe(i,:)=fscanf(f,'%i',npe);xv(i,:)=fscanf(f,'%i',npv);xt(i,:)=fscanf(f,'%i',npt);
    end
    fclose(f);

    %  entrenamento de SVM con datos Nd
    fprintf('entrenando LibSVM en %s Nd ...\n',problema);
    fprintf(fr,'%10s\t%10s\t%10s\n','C','gamma','%kappa');
    vC=2.^(15:-2:-5);nvC=length(vC);vG=2.^(3:-2:-15);nvG=length(vG);kappa=zeros(1,kfold);
    iexp=0;nexp=(nvC*nvG+1)*kfold;kappa_mellor=-inf;C_mellor=vC(1);G_mellor=vG(1);mc_med=zeros(C);mc_mellor=zeros(C);
    for i=1:nvC
        for j=1:nvG
            mc_med(:)=0;opct=sprintf('-s 0 -t 2 -c %g -g %g -q',vC(i),vG(j));  % opcións de svmtrain
            for k=1:kfold
                pe=xe(k,:);sd=cl(pe)';svm=svmtrain(sd,x(pe,:),opct);
                pv=xv(k,:);sd=cl(pv)';sr=svmpredict(sd,x(pv,:),svm);	
                [kappa(k),mc]=avalia(sd,sr);mc_med=mc_med+mc;
                fprintf('%6.2f%%\r', 100*iexp/nexp);iexp=iexp+1;
            end
            kappa_med=mean(kappa);mc_med=mc_med/kfold;
            if kappa_med > kappa_mellor
                kappa_mellor=kappa_med; C_mellor=vC(i);G_mellor=vG(j);mc_mellor=mc_med;
            end
            fprintf(fr,'%10f\t%10f\t%6.2f\n',vC(i),vG(j),kappa_med);
        end
    end
    fprintf(fr,'C_mellor= %g G_mellor= %g kappa_mellor= %6.2f%%\n',C_mellor,G_mellor,kappa_mellor);
    escribe(mc_mellor,'mellor');

    % realizando teste sobre conxuntos de teste
    mc_med(:)=0;	opct=sprintf('-s 0 -t 2 -c %g -g %g -q',C_mellor,G_mellor);
    for i=1:kfold
        pe=xe(i,:);sd=cl(pe)';svm=svmtrain(sd,x(pe,:),opct);
        pv=xt(i,:);sd=cl(pv)';sr=svmpredict(sd,x(pv,:),svm);
        [kappa(i),mc]=avalia(sd,sr);mc_med=mc_med+mc;
        fprintf('%6.2f%%\r', 100*iexp/nexp);iexp=iexp+1;
    end
    kappa_med=mean(kappa);mc_med=mc_med/kfold;
    fprintf(fr,'kappa_final= %6.2f\n',kappa_med);
    escribe(mc_med,'teste (kfold)');

    % almacena o kappa en kappa.dat
    nf=sprintf('../resultados/%s/svmNd/kappa.dat',problema);f=abre(nf,'w');
    fprintf(f,'%6.2f\n',kappa_med);fclose(f);

    fprintf('kappa= %6.2f%%\n',kappa_med);
    fclose(fr);
catch excepcion
    fprintf('matlab: excepción: problema= %s\n',problema)
    fprintf('id= %s: %s', excepcion.identifier, excepcion.message)
    fprintf('stack:\n')
    for i=1:size(excepcion.stack,1)
        fprintf('%s nome=%s linha=%i\n',excepcion.stack(i).file,...
            excepcion.stack(i).name,excepcion.stack(i).line)
    end
end
