function [w,mapeo]=topm(arg1,arg2,arg3)
% topm: Thornton index optimization polinomial mapping (TOPM)
    
    x=arg1;D=arg2;fct=factorial(1:D);
    
    % cálculo de vector w en 2D para patróns x non vistos durante o cálculo da proxección
    if 1==nargout()
        mapeo=arg3;x=bsxfun(@minus,x,mapeo.media);
        tz=x;z=tz; % mapeo polinómico (so termos puros)
        for d=2:D
            z=[z tz.^d/fct(d)];
        end
        w=z*mapeo.A;return
    end
    
    cl=arg3;
    mapeo.media=mean(x);
    x=bsxfun(@minus,x,mapeo.media);

    tz=x;z=tz; % mapeo polinómico (so termos puros)
    for d=2:D
        z=[z tz.^d/fct(d)];
    end

    d=dist2(z,z);[~,nn]=sort(d);
    j=nn(2,:);b=find(cl~=cl(j));
    p=size(z,2);Z=zeros(p);    
    for i=b
        k=j(i);
        dz=z(i,:)-z(k,:);
        Z=Z+dz'*dz;
    end
    [V,L]=eig(Z);    
    L(~isfinite(L))=0;L(imag(L)~=0)=0;
    [~,ind]=sort(abs(diag(L)),'descend');
    A=V(:,ind(1:2));w=z*A;mapeo.A=A;
end
